/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;
using SIPSorcery.SIP;

namespace SeriousSIP.Model
{
    [DataContract]
    public partial class CallInfoParams :  IEquatable<CallInfoParams>, IValidatableObject
    {
        public CallInfoParams(string id = default(string), string from = default(string), string to = default(string),
            SIPCallState state = SIPCallState.Unknown, SIPCallAction action = SIPCallAction.Idle, 
            SIPCallDirection direction = SIPCallDirection.None, uint rtpTx = 0, uint rtpRx = 0,
            string duration = default(string), string userContext = default(string), string[] sipHeaders = default(string[]))
        {
            this.Id = id;
            this.From = from;
            this.To = to;
            this.State = state;
            this.Action = action;
            this.Direction = direction;
            this.RtpTx = rtpTx;
            this.RtpRx = rtpRx;
            this.Duration = duration;
            this.UserContext = userContext;
            this.SipHeaders = sipHeaders;
        }
        
        /// <summary>
        /// Gets or Sets OnCallPlayDone
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public string Id { get; set; }

        /// <summary>
        /// Gets or Sets OnCallPlayFilesDone
        /// </summary>
        [DataMember(Name="from", EmitDefaultValue=false)]
        public string From { get; set; }

        /// <summary>
        /// Gets or Sets OnCallPlayRecordDone
        /// </summary>
        [DataMember(Name="to", EmitDefaultValue=false)]
        public string To { get; set; }

        /// <summary>
        /// Gets or Sets OnCallRecordDone
        /// </summary>
        [DataMember(Name="state", EmitDefaultValue=false)]
        public SIPCallState State { get; set; }

        /// <summary>
        /// Gets or Sets OnCallGetDigitsDone
        /// </summary>
        [DataMember(Name="action", EmitDefaultValue=false)]
        public SIPCallAction Action { get; set; }

        /// <summary>
        /// Gets or Sets OnCallSendDigitsDone
        /// </summary>
        [DataMember(Name="direction", EmitDefaultValue=false)]
        public SIPCallDirection Direction { get; set; }

        /// <summary>
        /// Gets or Sets OnCallSpeakDone
        /// </summary>
        [DataMember(Name="rtpTx", EmitDefaultValue=false)]
        public uint RtpTx { get; set; }

        /// <summary>
        /// Gets or Sets OnCallSpeakDone
        /// </summary>
        [DataMember(Name = "rtpRx", EmitDefaultValue = false)]
        public uint RtpRx { get; set; }

        /// <summary>
        /// Gets or Sets OnCallPlayRecordDone
        /// </summary>
        [DataMember(Name = "duration", EmitDefaultValue = false)]
        public string Duration { get; set; }

        /// <summary>
        /// Gets or Sets OnCallPlayRecordDone
        /// </summary>
        [DataMember(Name = "userContext", EmitDefaultValue = false)]
        public string UserContext { get; set; }

        /// <summary>
        /// Gets or Sets OnCallPlayRecordDone
        /// </summary>
        [DataMember(Name = "sipHeaders", EmitDefaultValue = false)]
        public string[] SipHeaders { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class CallInfoParams {\n");
            sb.Append("  id: ").Append(Id).Append("\n");
            sb.Append("  from: ").Append(From).Append("\n");
            sb.Append("  to: ").Append(To).Append("\n");
            sb.Append("  state: ").Append(State).Append("\n");
            sb.Append("  action: ").Append(Action).Append("\n");
            sb.Append("  direction: ").Append(Direction).Append("\n");
            sb.Append("  rtpTx: ").Append(RtpTx).Append("\n");
            sb.Append("  rtpRx: ").Append(RtpRx).Append("\n");
            sb.Append("  duration: ").Append(Duration).Append("\n");
            sb.Append("  userContext: ").Append(UserContext).Append("\n");
            sb.Append("  sipHeaders: ").Append(SipHeaders).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as CallInfoParams);
        }

        /// <summary>
        /// Returns true if CallMediaSubscriptions instances are equal
        /// </summary>
        /// <param name="input">Instance of CallMediaSubscriptions to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(CallInfoParams input)
        {
            if (input == null)
                return false;

            return true;
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
               
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
